@echo off

rem ------------------------------------------------------------------------------------
rem
rem	This file is a frontend to ppc386 compiler (distributed as part of FreePascal) 
rem	used along with devFlowcharter. This script expects zero or more of compiler 
rem 	parameters that start with dash sign (e.g. -g -Mtp) and one input file that 
rem	does not start with dash sign (e.g. BubbleSort.pas).
rem	Initial author of this file is Qiu Zhe.
rem
rem 	This program is distributed in the hope that it will be useful,
rem 	but WITHOUT ANY WARRANTY; without even the implied warranty of
rem 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
rem 	GNU General Public License for more details.
rem
rem ------------------------------------------------------------------------------------



set PATH=%~d0%~p0;%PATH%
set PARAMETERS_LIST=
set INPUT_FILE=
set INPUT_FILE_NOEXT=

:PROCESS_ARGUMENTS
IF (%1)==() GOTO :FORWARD
set ARG=%~1
IF /I (%ARG:~0,1%)==(-) (
	set PARAMETERS_LIST=%PARAMETERS_LIST% %ARG%
) ELSE (
	set INPUT_FILE=%ARG%
	set INPUT_FILE_NOEXT=%~n1
)
SHIFT
GOTO :PROCESS_ARGUMENTS
:FORWARD

IF EXIST "%INPUT_FILE_NOEXT%.exe" (del "%INPUT_FILE_NOEXT%.exe") 
IF EXIST "%INPUT_FILE_NOEXT%.o" (del "%INPUT_FILE_NOEXT%.o") 

@echo on
ppc386.exe %PARAMETERS_LIST% "%INPUT_FILE%"

@echo off
IF NOT EXIST "%INPUT_FILE_NOEXT%.exe" (GOTO :END)

set /p YES_NO=File "%INPUT_FILE%" was successfully compiled. Do you want to execute it? (y/n) 

IF %YES_NO%==y ("%INPUT_FILE_NOEXT%.exe")

:END
